/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.gui.widgets;

import java.awt.Color;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.system.swing.UIManagerKey;

/**
 *
 * @author babor
 */
public class SearchField extends javax.swing.JPanel
{

    private String emptyText = "Search";
    private final Color emptyForeground = Color.LIGHT_GRAY;
    private final Color defaultForeground;
    //not null string
    private String searchString = "";

    /**
     * Creates new form SearchField
     */
    public SearchField()
    {
        initComponents();
        defaultForeground = searchTF.getForeground();
        searchPanel.setBorder(UIManager.getBorder(UIManagerKey.TextField_border.getKey()));
        searchLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/small/magnifying_glass.png")));
        updateTextFieldAndClearButton();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        searchPanel = new javax.swing.JPanel();
        searchLabel = new javax.swing.JLabel();
        searchTF = new javax.swing.JTextField();
        clearButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        searchPanel.setBackground(javax.swing.UIManager.getDefaults().getColor("TextField.background"));
        searchPanel.setName("searchPanel"); // NOI18N
        searchPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 4);
        searchPanel.add(searchLabel, gridBagConstraints);

        searchTF.setBorder(null);
        searchTF.addFocusListener(new java.awt.event.FocusAdapter()
        {
            public void focusGained(java.awt.event.FocusEvent evt)
            {
                searchTFFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                searchTFFocusLost(evt);
            }
        });
        searchTF.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                searchTFActionPerformed(evt);
            }
        });
        searchTF.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                searchTFKeyReleased(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        searchPanel.add(searchTF, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 4);
        add(searchPanel, gridBagConstraints);

        clearButton.setText("x");
        clearButton.setEnabled(false);
        clearButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(clearButton, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void searchTFActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchTFActionPerformed
        updateSearchStringAndClearButton();
        fireStateChanged();
    }//GEN-LAST:event_searchTFActionPerformed

    private void searchTFFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_searchTFFocusLost
        updateTextFieldAndClearButton();
    }//GEN-LAST:event_searchTFFocusLost

    private void searchTFFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_searchTFFocusGained
        updateTextFieldAndClearButton();
    }//GEN-LAST:event_searchTFFocusGained

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        searchString = "";
        updateTextFieldAndClearButton();
        fireStateChanged();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void searchTFKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_searchTFKeyReleased
        updateSearchStringAndClearButton();
        fireStateChanged();
    }//GEN-LAST:event_searchTFKeyReleased

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearButton;
    private javax.swing.JLabel searchLabel;
    private javax.swing.JPanel searchPanel;
    private javax.swing.JTextField searchTF;
    // End of variables declaration//GEN-END:variables
    /**
     * @return the emptyText
     */
    public String getEmptySearchFieldText()
    {
        return emptyText;
    }

    /**
     * @param emptyText the emptyText to set
     */
    public void setEmptySearchFieldText(String emptyText)
    {
        this.emptyText = emptyText;
        updateTextFieldAndClearButton();
    }

    private void updateTextFieldAndClearButton()
    {
        boolean editingOrSearching = !searchString.isEmpty() || searchTF.hasFocus();
        searchTF.setForeground(editingOrSearching ? defaultForeground : emptyForeground);
        searchTF.setText(editingOrSearching ? searchString : emptyText);
        clearButton.setEnabled(!searchString.isEmpty());
    }

    public void setText(String text)
    {
        searchString = text;
        updateTextFieldAndClearButton();
    }

    private void updateSearchStringAndClearButton()
    {
        if (searchTF.getText().equals(emptyText)) searchString = "";
        else searchString = searchTF.getText();
        clearButton.setEnabled(!searchString.isEmpty());
    }

    /**
     * Utility field holding list of ActionListeners.
     */
    private transient ArrayList<ActionListener> actionListenerList;
    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList) {
            listener.stateChanged(e);
        }
    }

    /**
     * @return the searchString
     */
    public String getSearchString()
    {
        return searchString;
    }

    public static void main(String[] args)
    {
        SwingUtilities.invokeLater(new Runnable()
        {

            @Override
            public void run()
            {
                JFrame f = new JFrame();
                f.setLocationRelativeTo(null);
                f.add(new SearchField());
                f.pack();
                f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
                f.setVisible(true);
            }
        });
    }
}
